<?php
/*
Plugin Name: Thumb Cropper
Version: 0.2
Description: enables to customize image thumbnails
Plugin URI: http://fr.piwigo.org/ext/extension_view.php?eid=581
*/
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
include_once(PHPWG_ROOT_PATH.'include/functions_picture.inc.php');
include_once(PHPWG_ROOT_PATH.'admin/include/functions_upload.inc.php');

add_event_handler('ws_add_methods', 'add_tc_method');
add_event_handler('loc_begin_admin', 'tc_init_prefilter', 50); 

function add_tc_method($arr) {
	include_once('ws_functions.inc.php');
}

function tc_init_prefilter() {
	global $template;
	global $row,$conf;
	
	if (script_basename() != 'admin')
		return;
	if (isset($_GET['image_id'])) {
		$query = '
		SELECT *
		  FROM '.IMAGES_TABLE.'
		  WHERE id = '.$_GET['image_id'].'
		;';
		$row = pwg_db_fetch_assoc(pwg_query($query));
		$template->delete_compiled_templates();
		$thumb_data = array(
			'x1' => 0,
			'y1' => 0,
			'x2' => $row['width'],
			'y2' => $row['height'],
			'width' => $conf['upload_form_thumb_maxwidth'],
			'height' => $conf['upload_form_thumb_maxheight'],
		);
		
		$template->assign(array(
			'IMG_SRC' => get_image_url($row),
			'IMG_WIDTH' => $row['width'],
			'IMG_HEIGHT' => $row['height'],
			'IMG_ID' => $_GET['image_id'],
			'thumb_data' => $thumb_data,
			'TC_PWG_TOKEN' => get_pwg_token()
		));
		$template->set_prefilter('picture_modify','tc_prefilter');
	}
}

function tc_prefilter($content,&$smarty) {
	global $row;
	/* Only work if we are in the right tpl, pre_filter being called for every tpl found */
	if ($smarty->_current_file != 'picture_modify.tpl')
		return $content;
	/* Add Icon to page */
	$c = str_replace('<ul class="categoryActions">',
	'<ul class="categoryActions">'.
	'<a href="#thumbcropper" class="cbinline" title="{\'Edit thumbnail\'|@translate}">'.
	'<img src="plugins/thumbCropper/thumbcropper.png" alt="{\'Edit thumbnail\'|@translate}">'.
	'</a>',
	$content);
	/* Append new content */
	$c .= file_get_contents(dirname(__FILE__).'/thumbcropper.tpl');
	load_language('plugin.lang', dirname(__FILE__).'/');
	return $c;
}

?>